"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class DurationOfLabour(ProtocolElement):
    """
    Model that captures approximate duration of labour duration (this is
    the onset of regular contractions until delivery of placenta).
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.DurationOfLabour": participant_1_5_0.DurationOfLabour,
        }

    __slots__ = [
        "dateAndTimeOfLabourOnset",
        "firstStageHourDuration",
        "secondStageHourDuration",
        "thirdStageMinuteDuration",
    ]

    def __init__(
        self,
        dateAndTimeOfLabourOnset=None,
        firstStageHourDuration=None,
        secondStageHourDuration=None,
        thirdStageMinuteDuration=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.DurationOfLabour model.

        :param dateAndTimeOfLabourOnset:
            Date and time of labour onset.         String in ISO 8601 format with
            timezone and no microsecond.         format:
            %Y-%m-%dT%H:%M:%S+00:00         e.g.:
            2020-03-20T14:31:43+01:00
        :type dateAndTimeOfLabourOnset: None | str
        :param firstStageHourDuration:
            First stage (from 3cm and regular contractions) in hours.
        :type firstStageHourDuration: None | float
        :param secondStageHourDuration:
            Second stage (pushing) in hours.
        :type secondStageHourDuration: None | float
        :param thirdStageMinuteDuration:
            Third stage (delivery of placenta) in minutes.
        :type thirdStageMinuteDuration: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
